/* A simple wrapper to enable command line type programs to run in an
environment where there is no oportunity to enter command line parameters
(no file re-directs or wild cards) */

#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <ctype.h>
/* #include <io.h>
#include <sys\stat.h>
#include <dir.h>
*/

int _main(int, char **);

int main(int argc, char * argv[])
{
	char * targv[100];	/* room for 100 arguments */
	char targt[1000];	/* room for 1000 characters */
	char * line;
	char ** targs = targv;
	int targc, ret;

	/* see if we receieved any arguments */
	if (argc > 1)
		/* then just pass them along without any fuss */
		return  _main(argc, argv);

	/* read the command line in from screen */
	fputs("Enter command : ", stdout);
	line = targt;
	(void)gets(line);

	if (argc == 1)
		/* use program name if available */
		*targs++ = argv[0];
	else
		/* ANSI requirement when program name unavailable */
		*targs++ = (char *)"";

	/* now interpret the command line puting values into the pointers */
	for (;;)
	{
		char c;

		while (*line == ' ' || *line == '\t')
			line++;
		if (!*line)
			break;	/* end of command line */
		switch(c = *line)
		{
			case '\'':
			case '"':	/* quoted text */
				*targs++ = ++line;
				break;

			case '\\': /* continuation line */
				if (*(line + 1) == '\0') /* only if end of line */
				{	(void) puts("Continue command line: ");
					(void) gets(line);
					continue;
				}
				/* else drop through to default */

			default:
				*targs++ = line;
				c = '\0';
				break;
		}
		while (*line && (c?*line!=c:(*line!=' '&&*line!='\t')))
			line++;
		if (*line)
			*line++='\0';
	}
	*targs++ = NULL;		/* UNIX requirement */

	targc = (int)(targs - targv) - 1;

	/* now call the real main program with these values */
	fputs("\nProgram Starting\n\n", stdout);
	ret = _main(targc, targv);
	fputs("\nProgram Complete\n(hit return to exit)...", stdout);
	getchar();

	return ret;
}
